unit unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, StrUtils, Clipbrd, Vcl.Buttons,
  Vcl.ExtDlgs, system.UITypes;

type
  TForm1 = class(TForm)
    btnConnectClick: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Image1: TImage;
    Button5: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Button6: TButton;
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Panel1: TPanel;
    Button7: TButton;
    procedure btnConnectClickClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }

  public
    { Public 錾 }

 const
    WM_CAP_DRIVER_CONNECT           = WM_USER + 10;
    WM_CAP_DRIVER_DISCONNECT        = WM_USER + 11;
    WM_CAP_FILE_SET_CAPTURE_FILEA   = WM_USER + 20;
    WM_CAP_SAVEDIB                  = WM_USER + 25;
    WM_CAP_SEQUENCE                 = WM_USER + 62;
    WM_CAP_GRAB_FRAME               = WM_USER + 60;
    WM_CAP_SEQUENCE_NOFILE          = WM_USER + 63;
    WM_CAP_EDIT_COPY                = WM_USER + 30;
    WM_CAP_SET_OVERLAY              = WM_USER + 51;
    WM_CAP_SET_SCALE                = WM_USER + 53;
    WM_CAP_SET_PREVIEWRATE          = WM_USER + 52;
    WM_CAP_SET_PREVIEW              = WM_USER + 50;
    WM_CAP_STOP                     = WM_USER + 68;

    WM_CAP_SET_CALLBACK_VIDEOSTREAM = WM_USER + 6;
    WM_CAP_SET_CALLBACK_ERROR       = WM_USER + 2;
    WM_CAP_SET_CALLBACK_STATUSA     = WM_USER + 3;
    WM_CAP_SET_CALLBACK_FRAME       = WM_USER + 5;
    WM_CAP_GET_VIDEOFORMAT          = WM_USER + 44;
    WM_CAP_SET_VIDEOFORMAT          = WM_USER + 45;

    WM_CAP_DLG_VIDEOSOURCE          = WM_USER + 42;
    WM_CAP_DLG_VIDEOFORMAT          = WM_USER + 41;
    WM_CAP_DLG_VIDEODISPLAY         = WM_USER + 43;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  CaptureWnd   : HWND;
  Filename     : ansistring;
  lpBmpInfo    : Bitmapinfo;
  CaptureWidth : integer;
  CaptureHeight: integer;
  ViewWidth    : integer;
  ViewHeight   : integer;

// obt@TCYmۂłȂ̂
//  CaptureWidth  :integer  = 1280;     // NG
//  CaptureHeight :integer  = 960;

const
  str_Connect = 'WebJɐڑ';
  str_Disconn = 'ڑ';
  CaptureLeft     = 0;
  CaptureTop      = 0;

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';


function capCreateCaptureWindow(WindowName: PChar;
    dwStyle: Cardinal; x,y, nWidth,nHeight: Integer;
    ParentWin: HWnd; nID: Integer): HWnd; stdcall;
     external 'AVICAP32.DLL' name 'capCreateCaptureWindowW';


function capGetDriverDescription(wDriverIndex: DWORD;
    lpszName: LPWSTR; cbName : integer;
    lpszVer : LPWSTR; cbVer  : Integer): Boolean; stdcall;
     external 'AVICAP32.DLL' name 'capGetDriverDescriptionW';

procedure TForm1.btnConnectClickClick(Sender: TObject);
begin
  if (Sender as TButton).Caption = str_Connect then begin
    if RadioButton1.Checked then begin
      CaptureWidth    := 1280;     // ok
      CaptureHeight   := 720;
      ViewWidth       := 640;
      ViewHeight      := 360;
    end;
    if RadioButton2.Checked then begin
      CaptureWidth    := 640;     // ok
      CaptureHeight   := 480;
      ViewWidth       := 480;
      ViewHeight      := 360;
    end;
    if RadioButton3.Checked then begin
      CaptureWidth    := 640;     // ok
      CaptureHeight   := 360;
      ViewWidth       := 640;
      ViewHeight      := 360;
    end;
    Panel1.Width    := ViewWidth;
    Panel1.Height   := ViewHeight;
    // foCX̐ݒƃnh̎擾 摜̏o͐panel1
    CaptureWnd := capCreateCaptureWindow('Window',
        WS_CHILD or WS_VISIBLE, CaptureLeft, CaptureTop,
        CaptureWidth, CaptureHeight, Panel1.Handle, 0);
    if CaptureWnd <> 0 then begin
//      SendMessage(CaptureWnd, WM_CAP_SET_CALLBACK_VIDEOSTREAM, 0, 0);
//      SendMessage(CaptureWnd, WM_CAP_SET_CALLBACK_ERROR, 0, 0);
//      SendMessage(CaptureWnd, WM_CAP_SET_CALLBACK_STATUSA, 0, 0);

      //foCXւ̐ڑ
      SendMessage(CaptureWnd, WM_CAP_DRIVER_CONNECT, 0, 0);

      // J摜̒
//      SendMessage(CaptureWnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0);

      // J̉𑜓xƃtH[}bg̎w
      // WM_CAP_DLG_VIDEOFORMAT́A4:3 ōőTCY640~480łB
//      SendMessage(CaptureWnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0);

      // Video tH[}bg̎擾
      SendMessage(CaptureWnd, WM_CAP_GET_VIDEOFORMAT, sizeof(lpBmpInfo), Cardinal(@lpBmpInfo));
      // 𑜓x̐ݒ
      with lpbmpInfo.bmiHeader do begin
        biWidth := CaptureWidth;
        biHeight := CaptureHeight;
        biSizeImage := biWidth * biHeight * biBitCount div 8;
//        biCompression := BI_RGB;
      end;
      // Video tH[}bg̐ݒ
      SendMessage(CaptureWnd, WM_CAP_SET_VIDEOFORMAT, sizeof(lpBmpInfo), Cardinal(@lpBmpInfo));

      //vr[XP[ ϔ{Lݒ
      SendMessage(CaptureWnd, WM_CAP_SET_SCALE, 1, 0);
      //vr[̃R}i~bj
      SendMessage(CaptureWnd, WM_CAP_SET_PREVIEWRATE, 35, 0);

      // \TCY̎w
      SetWindowPos(CaptureWnd, HWND_BOTTOM, 0, 0,
           ViewWidth, ViewHeight,
           SWP_NOMOVE or SWP_NOZORDER);

      // vr[Jn
      SendMessage(CaptureWnd, WM_CAP_SET_PREVIEW, 1, 0);
    end;
    (Sender as TButton).Caption:= str_Disconn
  end
  else begin
    if CaptureWnd <> 0 then begin
      // foCXւ̐ڑ
      SendMessage(CaptureWnd, WM_CAP_DRIVER_DISCONNECT, 0, 0);
      // Capture悤Window̔j
      DestroyWindow(CaptureWnd);
      // nh̃NA
      CaptureWnd := 0;
      (Sender as TButton).Caption:= str_Connect;
    end;
  end;
end;

// Nbv{[hփRs[
procedure TForm1.Button1Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then
    SendMessage(CaptureWnd, WM_CAP_EDIT_COPY, 1, 0 );
end;

// t@C֕ۑ
// SendMessageőt@CAnsiString̕Kv܂B
procedure TForm1.Button2Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then begin
    SavePictureDialog1.Filter := '摜t@C|*.bmp';
    if SavePictureDialog1.Execute then begin
      Filename := ansistring(ChangeFileExt(SavePictureDialog1.FileName,'.bmp'));
    end
    else exit;
    SendMessage(CaptureWnd, WM_CAP_SAVEDIB, 0, Cardinal(pAnsiChar(Filename)));
  end;
end;

// t@Cւ̓ۑJn
// SendMessageőt@CAnsiString̕Kv܂B
procedure TForm1.Button3Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then begin
    SavePictureDialog1.Filter := 't@C|*.avi';
    if SavePictureDialog1.Execute then begin
      Filename := ansistring(ChangeFileExt(SavePictureDialog1.FileName,'.avi'));
    end
    else exit;
    SendMessage(CaptureWnd, WM_CAP_FILE_SET_CAPTURE_FILEA, 0, Cardinal(pAnsichar (Filename)));
    SendMessage(CaptureWnd, WM_CAP_SEQUENCE, 0, 0);
  end;
end;

// ۑ̒~
procedure TForm1.Button4Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then
    SendMessage(CaptureWnd, WM_CAP_STOP, 0, 0);
end;

// Nbv{[h摜\t
procedure TForm1.Button5Click(Sender: TObject);
var
  bitmm: TPicture;
begin
  if Clipboard.HasFormat(CF_DIB) then begin
    bitmm := TPicture.Create;
    try
      bitmm.Bitmap.Assign(Clipboard);
      Image1.Canvas.StretchDraw(rect(0, 0, CaptureWidth div 4, CaptureHeight div 4), bitmm.Bitmap);
    finally
      bitmm.Free;
    end;
  end;
end;

// hCo[o[W̎擾
procedure TForm1.Button6Click(Sender: TObject);
var
  Indx : Cardinal;
  szName, szVersion: array[0..MAX_PATH] of Char;
begin
  ListBox1.Clear;
  for Indx := 0 to 9 do begin
    if capGetDriverDescription(Indx, @szName, sizeof(szName), @szVersion, sizeof(szVersion)) then begin
      ListBox1.Items.Add(szName + ' (' + szVersion + ')');
    end;
  end;
end;

// Panle1ɕ\Ă摜̂܂܃Rs[ăt@Cɕۑ܂B
// t@C`WICŃT|[gĂSĂ̎ނłB
procedure TForm1.Button7Click(Sender: TObject);
label
  FEXIT;
var
  srcDC   : HDC;
  Bmp     : TBitmap;
  cBMP    : HBITMAP;
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  // Bitmap
  Bmp := TBitmap.Create;
  cBMP := 0;
  try
    srcDC := GetDC(Panel1.Handle);
// TCYݒ tH[}bgȂꍇ̓Rp`ݒ
// TCYw肵nh𐶐āABitmapnhɑ܂
    cBMP := CreateCompatibleBitmap(srcDC, ViewWidth, ViewHeight);
    Bmp.Handle := cBMP;
// tH[}bgRp`̏ꍇ̓TCŶݎwŉ
//    Bmp.Width := ViewWidth;
//    bmp.Height := ViewHeight;
    try
      // Bitmapɉ摜Rs[܂
      BitBlt(Bmp.Canvas.Handle, 0, 0,  ViewWidth, ViewHeight, srcDC, CaptureLeft, CaptureTop, SRCCOPY);
    finally
      ReleaseDC(Panel1.Handle, srcDC);
//      Findex := ReleaseDC(Panel1.Handle, srcDC);
    end;
    SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
    if not SavePictureDialog1.Execute then goto FEXIT;
    ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
    if ExeStr = '' then begin                                                // gqȂ
      Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
      case Findex of
        1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
           2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
           4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
           5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
           6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
           7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
      end;
    end
    else
      Fname := SavePictureDialog1.FileName;
    ExeStr := ExtractFileExt(Fname);                                         // gqo
    if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
      application.MessageBox('t@C̊gqԈĂ܂B','', 0);
      goto FEXIT;
    end;
    FnameTop := ExtractFileName(Fname);                                      // t@Co
    if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
      application.MessageBox('t@C܂B','', 0);
      goto FEXIT;
    end;

    if FileExists(Fname) then                                                // t@Cɂt@C
      if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then goto FEXIT;

    WIC := TWicImage.Create;                                                 // TWicImage
    try
      WIC.Assign(Bmp);                                                       // TWicImageɃrbg}bvf[^[t
      WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
      WIC.SaveTofile(Fname);                                                 // t@C̏o
    finally
      WIC.Free;                                                              // TWicImage
    end;
FEXIT:
  finally
    DeleteObject(cBmp);
    Bmp.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  top := (screen.Height - Height) div 2;
  left := (screen.Width - Width) div 2;
  btnConnectClick.Caption := str_Connect;
  CaptureWnd := 0;
  panel1.Caption := '';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if CaptureWnd <> 0 then begin
    SendMessage(CaptureWnd, WM_CAP_DRIVER_DISCONNECT, 0, 0);
    DestroyWindow(CaptureWnd);
  end;
end;

end.


